log-domain-0.13.2: Log-domain arithmetic

Copyright | (c) Edward Kmett 2013-2015
License | BSD3
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | experimental
Portability | non-portable
Safe Haskell | Safe-Inferred
Language | Haskell2010

Numeric.Log.Signed

Description

Synopsis

- data SignedLog a = SLExp {
  - signSL :: Bool
  - lnSL :: a
  }

# Documentation

data SignedLog a Source #

`Log`-domain `Float` and `Double` values, with a sign bit.

Constructors

SLExp |

Fields

- signSL :: Bool
- lnSL :: a

#### Instances

Instances details

Data a => Data (SignedLog a) Source # |

Instance details

Defined in Numeric.Log.Signed

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> SignedLog a -> c (SignedLog a) Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c (SignedLog a) Source #

toConstr :: SignedLog a -> Constr Source #

dataTypeOf :: SignedLog a -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c (SignedLog a)) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c (SignedLog a)) Source #

gmapT :: (forall b. Data b => b -> b) -> SignedLog a -> SignedLog a Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> SignedLog a -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> SignedLog a -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> SignedLog a -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> SignedLog a -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> SignedLog a -> m (SignedLog a) Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> SignedLog a -> m (SignedLog a) Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> SignedLog a -> m (SignedLog a) Source #

RealFloat a => Floating (SignedLog a) Source # |

Instance details

Defined in Numeric.Log.Signed

Methods

pi :: SignedLog a Source #

exp :: SignedLog a -> SignedLog a Source #

log :: SignedLog a -> SignedLog a Source #

sqrt :: SignedLog a -> SignedLog a Source #

(**) :: SignedLog a -> SignedLog a -> SignedLog a Source #

logBase :: SignedLog a -> SignedLog a -> SignedLog a Source #

sin :: SignedLog a -> SignedLog a Source #

cos :: SignedLog a -> SignedLog a Source #

tan :: SignedLog a -> SignedLog a Source #

asin :: SignedLog a -> SignedLog a Source #

acos :: SignedLog a -> SignedLog a Source #

atan :: SignedLog a -> SignedLog a Source #

sinh :: SignedLog a -> SignedLog a Source #

cosh :: SignedLog a -> SignedLog a Source #

tanh :: SignedLog a -> SignedLog a Source #

asinh :: SignedLog a -> SignedLog a Source #

acosh :: SignedLog a -> SignedLog a Source #

atanh :: SignedLog a -> SignedLog a Source #

log1p :: SignedLog a -> SignedLog a Source #

expm1 :: SignedLog a -> SignedLog a Source #

log1pexp :: SignedLog a -> SignedLog a Source #

log1mexp :: SignedLog a -> SignedLog a Source #

Generic (SignedLog a) Source # |

Instance details

Defined in Numeric.Log.Signed

Associated Types

type Rep (SignedLog a) |

Instance details

Defined in Numeric.Log.Signed

type Rep (SignedLog a) = D1 ('MetaData "SignedLog" "Numeric.Log.Signed" "log-domain-0.13.2-LrcSpVT0HKICDFS7fvty5o" 'False) (C1 ('MetaCons "SLExp" 'PrefixI 'True) (S1 ('MetaSel ('Just "signSL") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Bool) :*: S1 ('MetaSel ('Just "lnSL") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 a)))

Methods

from :: SignedLog a -> Rep (SignedLog a) x Source #

to :: Rep (SignedLog a) x -> SignedLog a Source #

RealFloat a => Num (SignedLog a) Source # |

Instance details

Defined in Numeric.Log.Signed

Methods

(+) :: SignedLog a -> SignedLog a -> SignedLog a Source #

(-) :: SignedLog a -> SignedLog a -> SignedLog a Source #

(*) :: SignedLog a -> SignedLog a -> SignedLog a Source #

negate :: SignedLog a -> SignedLog a Source #

abs :: SignedLog a -> SignedLog a Source #

signum :: SignedLog a -> SignedLog a Source #

fromInteger :: Integer -> SignedLog a Source #

(RealFloat a, Read a) => Read (SignedLog a) Source # |
Instance details Defined in Numeric.Log.Signed Methods readsPrec :: Int -> ReadS (SignedLog a) Source # readList :: ReadS [SignedLog a] Source # readPrec :: ReadPrec (SignedLog a) Source # readListPrec :: ReadPrec [SignedLog a] Source #
RealFloat a => Fractional (SignedLog a) Source # |
Instance details Defined in Numeric.Log.Signed Methods (/) :: SignedLog a -> SignedLog a -> SignedLog a Source # recip :: SignedLog a -> SignedLog a Source # fromRational :: Rational -> SignedLog a Source #
(RealFloat a, Ord a) => Real (SignedLog a) Source # |
Instance details Defined in Numeric.Log.Signed Methods toRational :: SignedLog a -> Rational Source #
RealFloat a => RealFrac (SignedLog a) Source # |
Instance details Defined in Numeric.Log.Signed Methods properFraction :: Integral b => SignedLog a -> (b, SignedLog a) Source # truncate :: Integral b => SignedLog a -> b Source # round :: Integral b => SignedLog a -> b Source # ceiling :: Integral b => SignedLog a -> b Source # floor :: Integral b => SignedLog a -> b Source #
(Show a, RealFloat a, Eq a, Fractional a) => Show (SignedLog a) Source # |
Instance details Defined in Numeric.Log.Signed Methods showsPrec :: Int -> SignedLog a -> ShowS Source # show :: SignedLog a -> String Source # showList :: [SignedLog a] -> ShowS Source #
(Eq a, Fractional a) => Eq (SignedLog a) Source # |
Instance details Defined in Numeric.Log.Signed Methods (==) :: SignedLog a -> SignedLog a -> Bool Source # (/=) :: SignedLog a -> SignedLog a -> Bool Source #
(Ord a, Fractional a) => Ord (SignedLog a) Source # |

Instance details

Defined in Numeric.Log.Signed

Methods

compare :: SignedLog a -> SignedLog a -> Ordering Source #

(<) :: SignedLog a -> SignedLog a -> Bool Source #

(<=) :: SignedLog a -> SignedLog a -> Bool Source #

(>) :: SignedLog a -> SignedLog a -> Bool Source #

(>=) :: SignedLog a -> SignedLog a -> Bool Source #

max :: SignedLog a -> SignedLog a -> SignedLog a Source #

min :: SignedLog a -> SignedLog a -> SignedLog a Source #

type Rep (SignedLog a) Source # |

Instance details

Defined in Numeric.Log.Signed

type Rep (SignedLog a) = D1 ('MetaData "SignedLog" "Numeric.Log.Signed" "log-domain-0.13.2-LrcSpVT0HKICDFS7fvty5o" 'False) (C1 ('MetaCons "SLExp" 'PrefixI 'True) (S1 ('MetaSel ('Just "signSL") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Bool) :*: S1 ('MetaSel ('Just "lnSL") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 a)))